// ---------------------------------------------------------------------------
//       High-Low.
// ---------------------------------------------------------------------------

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_minimum 0

//  .
extern int AveragePeriod         = 48;
//   .
extern color ColorOfCandleRange  = C'0,255,0';
extern color ColorOfAverageRange = C'255,0,0';

//  .
double range_candle[], range_average[];
//    .
int work_period;

// .
int init() {
  IndicatorShortName(StringConcatenate(
    "AZZX - BAR RANGE v1.0 (", AveragePeriod, ")"));
    
  SetIndexBuffer(0, range_candle);
  SetIndexBuffer(1, range_average);
  
  SetIndexLabel(0, NULL);
  SetIndexLabel(1, NULL);
  
  SetIndexEmptyValue(0, 0);
  SetIndexEmptyValue(1, 0);
  
  SetIndexStyle(0, DRAW_HISTOGRAM, EMPTY, EMPTY, ColorOfCandleRange);
  SetIndexStyle(1, DRAW_LINE,      EMPTY, EMPTY, ColorOfAverageRange);
  
  work_period = Bars - AveragePeriod;

  return(0);
}

//  .
int start() {
  int i;
  
  for(i = Bars - IndicatorCounted() - 1; i >= 0; i--) {
    range_candle[i ] = High[i] - Low[i];
    range_average[i] = average(i);
  }

  return(0);
}

//    .
double average(int bar) {
  if(bar > work_period) return(0);

  double r = 0;
  int    i;
  
  for(i = 0; i < AveragePeriod; i++, bar++) {
    r += range_candle[bar];
  }
  
  return(r / AveragePeriod);
}

